// This program doesn't support Unicode.

// for Win98 or later.
#define _WIN32_WINDOWS 0x0410

#include <windows.h>
#include "runtime.h"
#include "resource.h"
#include "bit.h"
#include "main.h"

UINT DrawFunc = 0;
UINT RollHeight = 4;
UINT RollWidth = 25;
int EmuPlayTempo = 100;
int EmuPlayKeypitch = 0;
int EmuPlayVolume = 80;
UINT FollowPlay = 0;
int FollowSpace = -1000;
int VisibleTrack = -1;
UINT PlayingPos = 0;

HWND hMainWnd;
HWND hDetailWnd;

COLORREF trackcolors[16] = {
	RGB(192, 192, 192),
	RGB(255, 128, 128),
	RGB(128, 255, 128),
	RGB(128, 128, 255),
	RGB(255, 255, 128),
	RGB(128, 255, 255),
	RGB(255, 128, 255),
	RGB(255, 255, 255),
	RGB(  0,   0,   0),
	RGB(128,   0,   0),
	RGB(  0, 128,   0),
	RGB(  0,   0, 128),
	RGB(128, 128,   0),
	RGB(  0, 128, 128),
	RGB(128,   0, 128),
	RGB(128, 128, 128),
};

// Emulation
HANDLE hEmuDLL;
BYTE* EmuBuf;
BYTE* EmuP;
// Prototypes
int (*MaSound_EmuInitialize)(DWORD, DWORD, BYTE*);
int (*MaSound_Initialize)(int, BYTE*, int);
int (*MaSound_DeviceControl)(int, int, int, int);
int (*MaSound_Terminate)();
int (*MaSound_Create)(int);
int (*MaSound_Load)(int, BYTE*, DWORD, int, int, int);
int (*MaSound_Control)(int, int, int, int*, int);
int (*MaSound_Open)(int, int, int, int);
int (*MaSound_Standby)(int, int, int);
int (*MaSound_Start)(int, int, int, int);
int (*MaSound_GetEmuInfo)(int);
int (*MaSound_Stop)(int, int, int);
int (*MaSound_Seek)(int, int, int, int, int);
int (*MaSound_Close)(int, int, int);
int (*MaSound_Unload)(int, int, int);
int (*MaSound_Delete)(int);
int (*MaSound_Terminate)();
int (*MaSound_EmuTerminate)();
int (*SetMidiMsg)(BYTE*, DWORD);
// And functions
BOOL InitEmuFunctions(HANDLE hdll)
{
	if(!((FARPROC)MaSound_EmuInitialize	= GetProcAddress(hdll, "MaSound_EmuInitialize")))	return TRUE;
	if(!((FARPROC)MaSound_Initialize	= GetProcAddress(hdll, "MaSound_Initialize")))		return TRUE;
	if(!((FARPROC)MaSound_DeviceControl	= GetProcAddress(hdll, "MaSound_DeviceControl")))	return TRUE;
	if(!((FARPROC)MaSound_Terminate		= GetProcAddress(hdll, "MaSound_Terminate")))		return TRUE;
	if(!((FARPROC)MaSound_Create		= GetProcAddress(hdll, "MaSound_Create")))			return TRUE;
	if(!((FARPROC)MaSound_Load			= GetProcAddress(hdll, "MaSound_Load")))			return TRUE;
	if(!((FARPROC)MaSound_Control		= GetProcAddress(hdll, "MaSound_Control")))			return TRUE;
	if(!((FARPROC)MaSound_Open			= GetProcAddress(hdll, "MaSound_Open")))			return TRUE;
	if(!((FARPROC)MaSound_Standby		= GetProcAddress(hdll, "MaSound_Standby")))			return TRUE;
	if(!((FARPROC)MaSound_Start			= GetProcAddress(hdll, "MaSound_Start")))			return TRUE;
	if(!((FARPROC)MaSound_GetEmuInfo	= GetProcAddress(hdll, "MaSound_GetEmuInfo")))		return TRUE;
	if(!((FARPROC)MaSound_Stop			= GetProcAddress(hdll, "MaSound_Stop")))			return TRUE;
	if(!((FARPROC)MaSound_Seek			= GetProcAddress(hdll, "MaSound_Seek")))			return TRUE;
	if(!((FARPROC)MaSound_Close			= GetProcAddress(hdll, "MaSound_Close")))			return TRUE;
	if(!((FARPROC)MaSound_Unload		= GetProcAddress(hdll, "MaSound_Unload")))			return TRUE;
	if(!((FARPROC)MaSound_Delete		= GetProcAddress(hdll, "MaSound_Delete")))			return TRUE;
	if(!((FARPROC)MaSound_Terminate		= GetProcAddress(hdll, "MaSound_Terminate")))		return TRUE;
	if(!((FARPROC)MaSound_EmuTerminate	= GetProcAddress(hdll, "MaSound_EmuTerminate")))	return TRUE;
	if(!((FARPROC)SetMidiMsg			= GetProcAddress(hdll, "SetMidiMsg")))				return TRUE;

	return FALSE;
}
BOOL EmuAllocate(void)
{
	EmuBuf = halloc(1024);	// Ƃ肠m
	EmuP = EmuBuf;
	// MaSound_EmuInitializeParam3̓AhX1oCg0x81ȉ?ĂJust0x81łȂĂ͂ȂȂ炵BAlign?
	while(((DWORD)EmuP & 0xFF) != 0x81)	// Ȃ񂩂킹Ȃƃ_炵
		EmuP++;

	return TRUE;
}
BOOL EmuDeallocate(void)
{
	hfree(EmuBuf);

	return TRUE;
}
// Call EmuInit() once on app starts.
BOOL EmuInit(void)
{
	if(!EmuAllocate())
	{
		return FALSE;
	}

	if(MaSound_EmuInitialize(48000, 0, EmuP))
	{
		MessageBox(NULL, "EmuInitialize0 failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}
// ȍ~Control(1,1,6,0,0)̃Xe[^XmFhĈłȂB
BOOL EmuOpen(SMAF* smaf)
{
	return TRUE;
}
BOOL EmuPlay(SMAF* smaf)
{
	MaSound_EmuTerminate();	// G[

	// Init
	if(MaSound_EmuInitialize(48000, 2, EmuP))
	{
		MessageBox(NULL, "EmuInitialize2 failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Initialize(0, EmuBuf/* + 0x2F*/, 0))	// ͑v?
	{
		MessageBox(NULL, "Initialize failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_DeviceControl(0x0D, 0, 0, 0))	// ꂪPCMȉȂȂ悤ŁB
	{
		MessageBox(NULL, "DeviceControl(0x0D, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_DeviceControl(0x05, 2, 0, 0))
	{
		MessageBox(NULL, "DeviceControl(0x05, 2, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_DeviceControl(0x06, 0, 0, 0))	// ŏɎsĂ̂AĂ݂
	{
		MessageBox(NULL, "DeviceControl(0x06, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_DeviceControl(0x08, 2, 0, 0))
	{
		MessageBox(NULL, "DeviceControl(0x08, 2, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_DeviceControl(0x09, 0, 0, 0))	// ŏɎsĂ̂AĂ݂ 2
	{
		MessageBox(NULL, "DeviceControl(0x09, 0, 0, 0) failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	// open
	if(MaSound_Create(1) != 1)
	{
		MessageBox(NULL, "Create failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Load(1, smaf->data, smaf->size, 1, (int)NULL, 0) != 1)	// ȂATS-MA5݂ƃR[obNۂǁAATS-MA5ł͈xĂ΂ĂȂBNULLw肵ĂOK̂ō̗pB
	{
		MessageBox(NULL, "Load failed!\nMay be incorrect SMAF specified.(CRC etc.)", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Open(1, 1, 0, 0))
	{
		MessageBox(NULL, "Open failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Standby(1, 1, 0))
	{
		MessageBox(NULL, "Standby failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	// Play
	if(MaSound_Control(1, 1, 0, &EmuPlayVolume, 0))	//  between 0 to 127
	{
		MessageBox(NULL, "Control volume failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Control(1, 1, 2, &EmuPlayKeypitch, 0))	// L[sb` between -12 to 12
	{
		MessageBox(NULL, "Control keypitch failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}
	if(MaSound_Control(1, 1, 1, &EmuPlayTempo, 0))	// e|(%) between 70 to 130.
	{
		MessageBox(NULL, "Control tempo failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	if(PlayingPos < smaf->start->time - smaf->start->duration)
		PlayingPos = smaf->start->time - smaf->start->duration;
	if(MaSound_Seek(1, 1, PlayingPos - (smaf->start->time - smaf->start->duration), 0, 0))
	{
		MessageBox(NULL, "Seek failed", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	if(MaSound_Start(1, 1, 1, 0))
	{
		MessageBox(NULL, "Start failed!", "Error", MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}
void EmuStop(void)
{
	MaSound_Stop(1, 1, 0);

	MaSound_Close(1, 1, 0);
	MaSound_Unload(1, 1, 0);
	MaSound_Delete(1);

	MaSound_Terminate();
	MaSound_EmuTerminate();

	if(MaSound_EmuInitialize(48000, 0, EmuP))
	{
		MessageBox(NULL, "EmuInitialize0 failed!", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	return;
}
void EmuClose(void)
{
	return;
}
void EmuTerminate(void)
{
	MaSound_EmuTerminate();

	EmuDeallocate();

	return;
}

//Đ̏
void EmuStatus(HWND hWnd)
{
	switch(MaSound_Control(1, 1, 6, 0, 0))
	{
	case 4:
		break;
	case 3:
		SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
		return;
	default:
		SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
		MessageBox(hWnd, "Status != 4,3\nSTOPPED.", "Error", MB_ICONERROR | MB_OK);
		return;
	}

	{
		TCHAR ts[256];
		DWORD emuinfo = MaSound_GetEmuInfo(4);

		wsprintf(ts, "MMF Tool %06ums ", PlayingPos);
		if(emuinfo & 0x01)
			lstrcat(ts, "LED ");
		if(emuinfo & 0x02)
			lstrcat(ts, "Vib ");
		SetWindowText(hWnd, ts);
	}

	return;
}




BOOL CALLBACK MessageDlgWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	if(msg == WM_INITDIALOG)
		return TRUE;
	if(msg == WM_COMMAND && (wParam == IDOK || wParam == IDCANCEL))
		EndDialog(hWnd, wParam);

	return FALSE;
}

BOOL findchunk4(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 4))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

BOOL findchunk3(BYTE* data, DWORD dsize, char* cname, CHUNK* ch)
{
	DWORD cur;

	for(cur = 0; cur < dsize; )
	{
		if(!memcomp(data + cur, cname, 3))
		{
			ch->data = data + cur + 8;
			ch->size = SwapDword(data + cur + 4);
			return TRUE;
		}
		cur += 8 + SwapDword(data + cur + 4);
	}

	return FALSE;
}

DWORD GetVValAndForward(BYTE** pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= **pdata & 0x7F;
	}while(*(*pdata)++ & 0x80);

	return val;
}

DWORD GetVValAndForward4HPS(BYTE** pdata)
{
	DWORD val = 0;

	if(**pdata & 0x80)
		val = (((*(*pdata)++) & 0x7F) + 1) << 7;

	val |= *(*pdata)++;

	return val;
}

DWORD GetVVal(BYTE* pdata)
{
	DWORD val = 0;

	do
	{
		val <<= 7;
		val |= *pdata & 0x7F;
	}while(*pdata++ & 0x80);

	return val;
}

void ClearEvents(SMAF* smaf)
{
	EVENT* e = smaf->events;

	while(e)
	{
		EVENT* next = e->next;
		hfree(e->data);
		hfree(e);
		e = next;
	}

	smaf->events = NULL;

	return;
}

void InsertEvent(SMAF* smaf, EVENT* e)
{
	EVENT* ev = smaf->events;
	EVENT* enx;

	// {e->timeOw
	if(ev)
	{
		while(ev->next)
		{
			if(e->time < ev->next->time)
				break;
			ev = ev->next;
		}
		//tdur = ev->time;
	}

	if(!ev)
	{
		enx = NULL;
		smaf->events = e;
	}else
	{
		enx = ev->next;
		ev->next = e;
	}

	e->next = enx;

	return;
}

// for HPS: convert to MSF
void ConvertEvents2(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop, UINT chshift)
{
	//EVENT* ev = smaf->events;
	BYTE* p;
	DWORD tdur = 0;
	signed int octshift[4] = {0};

	BOOL started = FALSE;
	BOOL stoped = FALSE;

	// go last event
	/*
	if(ev)
	{
		while(ev->next)
			ev = ev->next;
		//tdur = ev->time;
	}
	*/

	for(p = data; p < data + size; )
	{	// Ignore error ;-(
		// Maybe, there is more nice efficiency routine.
		EVENT* e;
		BYTE esize = 1;	// command size

		if(!fsetup)
		{
			if(!smaf->start && (DWORD)(p - data) == start)
				started = TRUE;
			if(!smaf->stop && (DWORD)(p - data) == stop)
				stoped = TRUE;
		}

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward4HPS(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = 0;
		e->size = 0;
		e->data = NULL;

		// Parse status!!
		if(p[0] == 0xFF && p[1] == 0xF0)	// Exclusive
		{
			esize = 2 + 1 + p[2];
#if 0
			e->size = 1 + p[2];
			e->status = 0xF0;
			e->data = halloc(e->size);
			memcopy(e->data, p + 2, e->size);
#endif
			hfree(e);
			p += esize;
			continue;
		}else if(p[0] == 0xFF && p[1] == 0x00)	// NOP
		{
			esize = 2;
			e->size = 1;
			e->data = halloc(e->size);
			e->status = 0xFF;
			e->data[0] = 0x00;
		}else
		{
			if(p[0] != 0x00)	// Note
			{
				BYTE ch;
				BYTE oct;
				BYTE note;
				BYTE absnote;

				ch = (p[0] >> 6 & 0x03);
				oct = p[0] >> 4 & 0x03;
				note = p[0] & 0x0F;
				// MIDI's 69 = 440Hz(A) = Oct2,9
				absnote = 36 + (oct + octshift[ch]) * 12 + note;

				e->status = 0x80 | (ch + chshift);
				{
					BYTE* q = p + 1;

					GetVValAndForward4HPS(&q);
					esize = q - p;
					{
						DWORD siz;
						siz = q - p;
						if(siz == 1 + 2 && p[1] == 0xFF)	// vval over 2byte.
							siz++;
						e->size = siz;
					}
					e->data = halloc(e->size);

					e->data[0] = absnote;
					if(p[1] & 0x80)
					{
						if(p[1] == 0xFF)
						{
							e->data[1] = 0x80;
							e->data[2] = p[1] + 1;
							e->data[3] = p[2];
						}else
						{
							e->data[1] = p[1] + 1;
							e->data[2] = p[2];
						}
					}else
						e->data[1] = p[1];
				}
			}else
			{
				BYTE ch;
				ch = (p[1] >> 6 & 0x03) + chshift;

				if(p[1] == 0x00 && p[2] == 0x00 && p[3] == 0x00)	// EOS?
					esize = 4;
				if((p[1] & 0x30) == 0x30)
				{
					if((p[1] & 0x0F) == 0x00)	// Program Change
					{
						esize = 3;
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xC0 | ch;
						e->data[0] = p[2];
					}
					if((p[1] & 0x0F) == 0x01)	// Bank Select
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x00;	// banksel
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x02)	// Octave Shift
					{
						UINT ch = p[0] >> 6 & 0x03;

						esize = 3;
						octshift[ch] = p[2];
						if(octshift[ch] > 0x81)
							octshift[ch] = -(octshift[ch] - 0x80);

#if 0
						// NOP
						e->size = 1;
						e->data = halloc(e->size);
						e->status = 0xFF;
						e->data[0] = 0x00;
#endif
						hfree(e);
						p += esize;

						continue;
					}
					if((p[1] & 0x0F) == 0x03)	// Modulation
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x04)	// PitchBend
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = p[2];	// tenuki.
					}
					if((p[1] & 0x0F) == 0x07)	// Volume
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x07;	// vol
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0A)	// Pan
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0A;	// pan
						e->data[1] = p[2];
					}
					if((p[1] & 0x0F) == 0x0B)	// Expression
					{
						esize = 3;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = p[2];
					}
				}else
				{
					if((p[1] & 0x30) == 0x00)	// Expression
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x0B;	// exp.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
					if((p[1] & 0x30) == 0x10)	// PitchBend
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xE0 | ch;
						e->data[0] = 0x00;
						e->data[1] = (p[1] & 0xF0) << 3;	// chou tenuki
					}
					if((p[1] & 0x30) == 0x20)	// Modulation
					{
						esize = 2;
						e->size = 2;
						e->data = halloc(e->size);
						e->status = 0xB0 | ch;
						e->data[0] = 0x01;	// mod.
						e->data[1] = (p[1] & 0xF0) << 3;
					}
				}
			}
		}

		if(esize == 1)
		{
			TCHAR ts[256];

			wsprintf(ts, "What's this? %02X", p[0]);
			MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);
		}

		p += esize;

		InsertEvent(smaf, e);
		/*
		e->next = NULL;

		if(!ev)
			smaf->events = e;
		else
			ev->next = e;
		*/

		if(started)
		{
			smaf->start = e;
			started = FALSE;
		}
		if(stoped)
		{
			smaf->stop = e;
			stoped = FALSE;
		}
	}

	return;
}

// for MSF
void ConvertEvents(SMAF* smaf, BYTE* data, DWORD size, BOOL fsetup, DWORD start, DWORD stop)
{
	//EVENT* ev = smaf->events;
	BYTE* p;
	DWORD tdur = 0;

	BOOL started = FALSE;
	BOOL stoped = FALSE;

	/*
	if(ev)
	{
		while(ev->next)
			ev = ev->next;
		tdur = ev->time;
	}
	*/

	for(p = data; p < data + size; )
	{	// Ignore error ;-(
		// Maybe, there is more nice efficiency routine.
		EVENT* e;

		if(!fsetup)
		{
			if((DWORD)(p - data) == start)
				started = TRUE;
			if((DWORD)(p - data) == stop)
				stoped = TRUE;
		}

		e = halloc(sizeof(EVENT));
		if(fsetup)
			e->duration = 0;
		else
			e->duration = GetVValAndForward(&p) * smaf->dbase;
		tdur += e->duration;
		e->time = tdur;
		e->status = *p++;
		e->size = 0;
		e->data = NULL;

		// Parse status!!
		if((e->status & 0xF0) == 0x80)	// Note w/o verocity
		{
			BYTE* q = p + 1;

			GetVValAndForward(&q);
			e->size = q - p;
		}
		if((e->status & 0xF0) == 0x90)	// Note w/ verocity
		{
			BYTE* q = p + 2;

			GetVValAndForward(&q);
			e->size = q - p;
		}
		if((e->status & 0xF0) == 0xA0)	// Resv 3byte
		{
			e->size = 3;
		}
		if((e->status & 0xF0) == 0xB0)	// Control Change
		{
			e->size = 2;
		}
		if((e->status & 0xF0) == 0xC0)	// Program Change
		{
			e->size = 1;
		}
		if((e->status & 0xF0) == 0xD0)	// Resv 2byte
		{
			e->size = 2;
		}
		if((e->status & 0xF0) == 0xE0)	// PitchBend
		{
			e->size = 2;
		}
		if(e->status == 0xF0)	// Exclusive
		{
			BYTE* q = p;

			e->size = GetVValAndForward(&q);
			e->size += (q - p);	// VVal size
		}
		if(e->status == 0xFF)	// NOP or EOS
		{
			if(*p == 0x00)
				e->size = 1;
			if(*p == 0x2F)
				e->size = 2;
		}

		// copy.
		if(e->size)
		{
			e->data = halloc(e->size);
			memcopy(e->data, p, e->size);
			p += e->size;
		}else
			MessageBox(NULL, "Bug or illegal", "What", MB_OK);

		InsertEvent(smaf, e);
		/*
		e->next = NULL;

		if(!ev)
			smaf->events = e;
		else
			ev->next = e;
		*/

		if(started)
		{
			smaf->start = e;
			started = FALSE;
		}
		if(stoped)
		{
			smaf->stop = e;
			stoped = FALSE;
		}

		//ev = e;
	}

#if 0
	// for debugging test
	{
		EVENT* e;

		e = halloc(sizeof(EVENT));
		e->duration = 0;
		tdur += e->duration * dbase;
		e->time = tdur;
		e->status = 0xFF;
		e->size = 1;
		e->data = halloc(e->size);
		e->data[0] = 0x00;
		e->next = NULL;
		ev->next = e;
	}
#endif

	return;
}

DWORD drawdetail(HWND hWnd, HDC hdc, int width, int height, SMAF* smaf, DWORD playingpos)
{
	HFONT hfold;

	SaveDC(hdc);

	SetTextColor(hdc, RGB(0, 0, 0));
	SetBkMode(hdc, OPAQUE);

	{
		LOGFONT lf = {0};

		lf.lfCharSet = DEFAULT_CHARSET;
		strcopy(lf.lfFaceName, "lr SVbN");
		lf.lfHeight = -12;

		hfold = SelectObject(hdc, CreateFontIndirect(&lf));
	}

	{
		SCROLLINFO vsi, hsi;

		vsi.cbSize = hsi.cbSize = sizeof(SCROLLINFO);
		vsi.fMask = hsi.fMask = SIF_POS;
		GetScrollInfo(hWnd, SB_VERT, &vsi);
		GetScrollInfo(hWnd, SB_HORZ, &hsi);

		{
			SIZE s;

			GetTextExtentPoint32(hdc, "A", 1, &s);
			MoveToEx(hdc, hsi.nPos * -s.cx, vsi.nPos * -s.cy, NULL);
		}
	}

	if(!smaf)
	{
		FillRectangle(hdc, 0, 0, width, height, GetSysColor(COLOR_3DFACE));
		SetBkColor(hdc, GetSysColor(COLOR_3DFACE));

		PutText(hdc, "SMAF not opened.");

		goto ret;
	}else
	{
		FillRectangle(hdc, 0, 0, width, height, GetSysColor(COLOR_WINDOW));
		SetBkColor(hdc, GetSysColor(COLOR_WINDOW));
	}

	{
		CHUNK mmmd;
		CHUNK dummy;

		if(!findchunk4(smaf->data, smaf->size, "MMMD", &mmmd))
		{
			PutText(hdc, "MMMD NOT FOUND");
			goto ret;
		}

		mmmd.size -= 2;	// CRC

		{
			CHUNK cnti;

			if(!findchunk4(mmmd.data, mmmd.size, "CNTI", &cnti))
			{
				PutText(hdc, "CNTI NOT FOUND");
				goto ret;
			}

			PutText(hdc, "CNTI info");

			if(cnti.data[0] == 0x00)
				PutText(hdc, "Contents class: YAMAHA");
			else
				PutText(hdc, "Contents class: Not yamaha %02X", cnti.data[0]);

			if((0x00 <= cnti.data[1] && cnti.data[1] <= 0x0F) || (0x30 <= cnti.data[1] && cnti.data[1] <= 0x33))
				PutText(hdc, "Contents type: Ringtone %02X", cnti.data[1]);
			else if((0x10 <= cnti.data[1] && cnti.data[1] <= 0x1F) || (0x40 <= cnti.data[1] && cnti.data[1] <= 0x42))
				PutText(hdc, "Contents type: Karaoke %02X", cnti.data[1]);
			else if((0x20 <= cnti.data[1] && cnti.data[1] <= 0x2F) || (0x50 <= cnti.data[1] && cnti.data[1] <= 0x53))
				PutText(hdc, "Contents type: CM %02X", cnti.data[1]);
			else
				PutText(hdc, "Contents type: RESERVED %02X", cnti.data[1]);

			switch(cnti.data[2])
			{
			case 0x00: PutText(hdc, "Contents code: Shift-JIS"); break;
			case 0x01: PutText(hdc, "Contents code: Latin-1"); break;
			case 0x02: PutText(hdc, "Contents code: EUC-KR"); break;
			case 0x03: PutText(hdc, "Contents code: GB-2312"); break;
			case 0x04: PutText(hdc, "Contents code: Big5"); break;
			case 0x05: PutText(hdc, "Contents code: KOI8-R"); break;
			case 0x06: PutText(hdc, "Contents code: TCVN-5773:1993"); break;
			case 0x20: PutText(hdc, "Contents code: UCS-2"); break;
			case 0x21: PutText(hdc, "Contents code: UCS-4"); break;
			case 0x22: PutText(hdc, "Contents code: UTF-7"); break;
			case 0x23: PutText(hdc, "Contents code: UTF-8"); break;
			case 0x24: PutText(hdc, "Contents code: UTF-16"); break;
			case 0x25: PutText(hdc, "Contents code: UTF-32"); break;
			default: PutText(hdc, "Contents code: RESERVED %02X", cnti.data[2]); break;
			}

			if(cnti.data[3] & 0x04)
				PutText(hdc, "CopyStatus: Edit NG");
			else
				PutText(hdc, "CopyStatus: Edit OK");
			if(cnti.data[3] & 0x02)
				PutText(hdc, "CopyStatus: Save NG");
			else
				PutText(hdc, "CopyStatus: Save OK");
			if(cnti.data[3] & 0x01)
				PutText(hdc, "CopyStatus: Trans NG");
			else
				PutText(hdc, "CopyStatus: Trans OK");

			PutText(hdc, "Copy Count: %d", cnti.data[4]);

			if(cnti.size > 5)
			{
				DWORD i, j;

				PutText(hdc, "Optional data followed.");

				for(i = 5; i < cnti.size; )
				{
					char tag[16];
					char data[256];
					char* p;

					tag[0] = cnti.data[i];
					tag[1] = cnti.data[i + 1];
					tag[2] = '\0';

					if(cnti.data[i] == 'V' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Vendor");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Carrior");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'A')
						lstrcpy(tag, "Category");
					if(cnti.data[i] == 'S' && cnti.data[i + 1] == 'T')
						lstrcpy(tag, "Title");
					if(cnti.data[i] == 'A' && cnti.data[i + 1] == 'N')
						lstrcpy(tag, "Artist");
					if(cnti.data[i] == 'W' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Word");
					if(cnti.data[i] == 'S' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Music");
					if(cnti.data[i] == 'A' && cnti.data[i + 1] == 'W')
						lstrcpy(tag, "Edit");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'R')
						lstrcpy(tag, "Copyright");
					if(cnti.data[i] == 'G' && cnti.data[i + 1] == 'R')
						lstrcpy(tag, "CR-Group");
					if(cnti.data[i] == 'M' && cnti.data[i + 1] == 'I')
						lstrcpy(tag, "ManInfo");
					if(cnti.data[i] == 'C' && cnti.data[i + 1] == 'D')
						lstrcpy(tag, "Create");
					if(cnti.data[i] == 'U' && cnti.data[i + 1] == 'D')
						lstrcpy(tag, "Update");
					if(cnti.data[i] == ' ' && cnti.data[i + 1] == 'C')
						lstrcpy(tag, "Copy by?");
					i += 3;

					// Shift-JISƂlĂ܂cB
					for(j = i, p = data; /*Fact=IllegalFile->*/j < cnti.size; j++)
					{
						if(cnti.data[j] == ',')
						{
							if(cnti.data[j - 1] != '\\')
							{
								*p = '\0';
								break;
							}else
							{
								*(p - 1) = ',';
							}
						}else
						{
							*p = cnti.data[j];
							p++;
						}
					}

					//memcopy(data, cnti.data + i, j - i);
					//data[j - i] = '\0';

					i = j + 1;

					{
						TCHAR ts[256];
						wsprintf(ts, "%s: %s", tag, data);
						PutText(hdc, ts);
					}
				}
			}
		}

		{
			CHUNK opda;

			if(findchunk4(mmmd.data, mmmd.size, "OPDA", &opda))
			{
				CHUNK dch;
				PutText(hdc, "OPDA found.");

				if(findchunk3(opda.data, opda.size, "Dch", &dch))
				{
					DWORD i;
					PutText(hdc, "Dch found.");

					for(i = 0; i < dch.size; )
					{
						char tag[16];
						char data[256];

						tag[0] = dch.data[i];
						tag[1] = dch.data[i + 1];
						tag[2] = '\0';

						if(dch.data[i] == 'V' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Vendor");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Carrior");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'A')
							lstrcpy(tag, "Category");
						if(dch.data[i] == 'S' && dch.data[i + 1] == 'T')
							lstrcpy(tag, "Title");
						if(dch.data[i] == 'A' && dch.data[i + 1] == 'N')
							lstrcpy(tag, "Artist");
						if(dch.data[i] == 'W' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Word");
						if(dch.data[i] == 'S' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Music");
						if(dch.data[i] == 'A' && dch.data[i + 1] == 'W')
							lstrcpy(tag, "Edit");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'R')
							lstrcpy(tag, "Copyright");
						if(dch.data[i] == 'G' && dch.data[i + 1] == 'R')
							lstrcpy(tag, "CR-Group");
						if(dch.data[i] == 'M' && dch.data[i + 1] == 'I')
							lstrcpy(tag, "ManInfo");
						if(dch.data[i] == 'C' && dch.data[i + 1] == 'D')
							lstrcpy(tag, "Create");
						if(dch.data[i] == 'U' && dch.data[i + 1] == 'D')
							lstrcpy(tag, "Update");
						if(dch.data[i] == 'E' && dch.data[i + 1] == 'S')
							lstrcpy(tag, "EditState");
						if(dch.data[i] == 'V' && dch.data[i + 1] == 'C')
							lstrcpy(tag, "vCard");
						if(dch.data[i] == ' ' && dch.data[i + 1] == 'C')
							lstrcpy(tag, "Copy by?");
						i += 2;

						memcopy(data, dch.data + i + 2, SwapWord(dch.data + i));
						data[SwapWord(dch.data + i)] = '\0';

						i += SwapWord(dch.data + i) + 2;

						{
							TCHAR ts[256];
							wsprintf(ts, "%s: %s", tag, data);
							PutText(hdc, ts);
						}					
					
					}
				}
			}
		}

		{
			CHUNK mtr;

			if(findchunk3(mmmd.data, mmmd.size, "MTR", &mtr))
			{
				PutText(hdc, "MTR info");

				switch(mtr.data[0])
				{
				case 0x00: PutText(hdc, "Format Type: HandyPhone Standard (MA-1,2)"); break;
				case 0x01: PutText(hdc, "Format Type: Mobile Standard(Compress)"); break;
				case 0x02: PutText(hdc, "Format Type: Mobile Standard(No Compress) (MA-3,5)"); break;
				case 0x03: PutText(hdc, "Format Type: MA-7"); break;
				default: PutText(hdc, "Format Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[1])
				{
				case 0x00: PutText(hdc, "Sequence Type: Stream sequence"); break;
				case 0x01: PutText(hdc, "Sequence Type: Sub-sequence"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[2])
				{
				case 0x00: PutText(hdc, "TimeBase(Duration): 1 msec"); break;
				case 0x01: PutText(hdc, "TimeBase(Duration): 2 msec"); break;
				case 0x02: PutText(hdc, "TimeBase(Duration): 4 msec"); break;
				case 0x03: PutText(hdc, "TimeBase(Duration): 5 msec"); break;
				case 0x10: PutText(hdc, "TimeBase(Duration): 10 msec"); break;
				case 0x11: PutText(hdc, "TimeBase(Duration): 20 msec"); break;
				case 0x12: PutText(hdc, "TimeBase(Duration): 40 msec"); break;
				case 0x13: PutText(hdc, "TimeBase(Duration): 50 msec"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				switch(mtr.data[3])
				{
				case 0x00: PutText(hdc, "TimeBase(GateTime): 1 msec"); break;
				case 0x01: PutText(hdc, "TimeBase(GateTime): 2 msec"); break;
				case 0x02: PutText(hdc, "TimeBase(GateTime): 4 msec"); break;
				case 0x03: PutText(hdc, "TimeBase(GateTime): 5 msec"); break;
				case 0x10: PutText(hdc, "TimeBase(GateTime): 10 msec"); break;
				case 0x11: PutText(hdc, "TimeBase(GateTime): 20 msec"); break;
				case 0x12: PutText(hdc, "TimeBase(GateTime): 40 msec"); break;
				case 0x13: PutText(hdc, "TimeBase(GateTime): 50 msec"); break;
				default: PutText(hdc, "Sequence Type: RESERVED %02X", mtr.data[0]); break;
				}

				if(mtr.data[0] == 0x00)
				{
					LPCTSTR chtypes[4] = {"NO CARE", "Melody", "No Melody", "Rhythm"};
					PutText(hdc, "Analysing MA-2 deep...");

					PutText(hdc, "Channel 1: KCS=%s VS=%s ChType=%s", (mtr.data[4] & 0x80) ? "ON" : "OFF", (mtr.data[4] & 0x40) ? "ON" : "OFF", chtypes[(mtr.data[4] >> 4) & 0x03]);
					PutText(hdc, "Channel 2: KCS=%s VS=%s ChType=%s", (mtr.data[4] & 0x08) ? "ON" : "OFF", (mtr.data[4] & 0x04) ? "ON" : "OFF", chtypes[mtr.data[4] & 0x03]);
					PutText(hdc, "Channel 3: KCS=%s VS=%s ChType=%s", (mtr.data[5] & 0x80) ? "ON" : "OFF", (mtr.data[5] & 0x40) ? "ON" : "OFF", chtypes[(mtr.data[5] >> 4) & 0x03]);
					PutText(hdc, "Channel 4: KCS=%s VS=%s ChType=%s", (mtr.data[5] & 0x08) ? "ON" : "OFF", (mtr.data[5] & 0x04) ? "ON" : "OFF", chtypes[mtr.data[5] & 0x03]);
				}

				if(mtr.data[0] == 0x02 || mtr.data[0] == 0x01)
				{
					PutText(hdc, "Analysing MA-3,5 deep...");

					{
						int i;
						for(i = 0; i < 16; i++)
						{
							TCHAR ts[1024];
							wsprintf(ts, "Channel %i: KCS=", i);
							switch(mtr.data[4 + i] >> 6)
							{
							case 0x00: lstrcat(ts, "None "); break;
							case 0x01: lstrcat(ts, "OFF "); break;
							case 0x02: lstrcat(ts, "ON "); break;
							case 0x03: lstrcat(ts, "RESERVED "); break;
							}
							if(mtr.data[4 + i] & 0x20)
								lstrcat(ts, "Vib ");
							if(mtr.data[4 + i] & 0x10)
								lstrcat(ts, "LED ");
							switch(mtr.data[4 + i] & 0x03)
							{
							case 0x00: lstrcat(ts, "Nocare "); break;
							case 0x01: lstrcat(ts, "Melody "); break;
							case 0x02: lstrcat(ts, "NON Melody "); break;
							case 0x03: lstrcat(ts, "Rhythm "); break;
							}
							PutText(hdc, ts);
						}
					}

					mtr.data += 4 + 16;

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
						PutText(hdc, "MspI Info found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						PutText(hdc, "Mtsu Setup found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
						PutText(hdc, "Mtsq Sequence found.");

					if(findchunk4(mtr.data, mtr.size, "Mtsp", &dummy))
						PutText(hdc, "Mtsp PCM found.");
				}
			}
		}
	}

	PutText(hdc, "EventList!");

	{
		EVENT* e = smaf->events;
		DWORD count = 0;
		BOOL marked = FALSE;

		PutText(hdc, "<Line No.> Dur. St(Len): data...");
		PutText(hdc, "---");

		while(e)
		{
			TCHAR ts[1024];
			DWORD i;
			DWORD max;
			POINT pt;

			wsprintf(ts, "<%08d> %08dms %02X(%3d): ", count++, e->time, e->status, e->size);
			max = e->size;
			if(256 < max)
				max = 256;
			for(i = 0; i < max; i++)
			{
				TCHAR hex[4];
				wsprintf(hex, "%02X ", e->data[i]);
				lstrcat(ts, hex);
			}
			GetCurrentPositionEx(hdc, &pt);
			PutText(hdc, ts);

			if(!marked && playingpos <= e->time)
			{
				HPEN hpold;

				marked = TRUE;

				SaveDC(hdc);

				hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(255, 0, 0)));
				MoveToEx(hdc, 0, pt.y, NULL);
				LineTo(hdc, width, pt.y);
				DeleteObject(SelectObject(hdc, hpold));

				RestoreDC(hdc, -1);
			}

			e = e->next;
		}
	}

	PutText(hdc, "READY");
ret:
	{
		SIZE s;
		POINT p;
		SCROLLINFO vsi;

		vsi.cbSize = sizeof(SCROLLINFO);
		vsi.fMask = SIF_POS;
		GetScrollInfo(hWnd, SB_VERT, &vsi);

		GetTextExtentPoint32(hdc, "A", 1, &s);

		DeleteObject(SelectObject(hdc, hfold));

		GetCurrentPositionEx(hdc, &p);

		RestoreDC(hdc, -1);

		return p.y / s.cy + vsi.nPos;
	}
}

void draw(HWND hWnd, HDC hdc, int width, int height, SMAF* smaf, DWORD playingpos)
{
	HFONT hfold;
	int scrx, scry;

	SetTextColor(hdc, RGB(0, 0, 0));
	SetBkMode(hdc, TRANSPARENT);

	if(!smaf)
	{
		FillRectangle(hdc, 0, 0, width, height, GetSysColor(COLOR_3DFACE));
		MoveToEx(hdc, 0, 0, NULL);
		PutText(hdc, "Open please.");

		return;
	}

	FillRectangle(hdc, 0, 0, width, height, RGB(255, 255, 255));

	{
		LOGFONT lf = {0};

		lf.lfCharSet = DEFAULT_CHARSET;
		strcopy(lf.lfFaceName, "lr SVbN");
		lf.lfHeight = -12;

		hfold = SelectObject(hdc, CreateFontIndirect(&lf));
	}

	{
		SCROLLINFO vsi, hsi;

		vsi.cbSize = hsi.cbSize = sizeof(SCROLLINFO);
		vsi.fMask = hsi.fMask = SIF_POS;
		GetScrollInfo(hWnd, SB_VERT, &vsi);
		GetScrollInfo(hWnd, SB_HORZ, &hsi);

		scrx = hsi.nPos;
		scry = vsi.nPos;
	}

	// draw pianoroll
	{
		int i;
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(220, 220, 220)));
		COLORREF oldcolor = SetTextColor(hdc, RGB(192, 192, 192));
		EVENT* e;

		// draw horizontal grid
		for(i = 0; i < 128; i++)
		{
			MoveToEx(hdc, 0, (127 - i) * RollHeight - scry, NULL);
			LineTo(hdc, width, (127 - i) * RollHeight - scry);

			if(!(i % 12))
			{
				FillRectangle(hdc, 0, (127 - i) * RollHeight - scry + 1, width, (127 - i + 1) * RollHeight - scry, RGB(240, 240, 240));
			}
		}

		// draw vertical grid
		for(i = -(scrx * (int)RollWidth % 100); i < width * (int)RollWidth; i += 100)
		{
			HPEN hpold;

			if(!((i + scrx * RollWidth) % (50 * RollWidth)))
				hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(192, 192, 192)));

			MoveToEx(hdc, i / RollWidth, 0, NULL);
			LineTo(hdc, i / RollWidth, height);

			if(!((i + scrx * RollWidth) % (50 * RollWidth)))
				DeleteObject(SelectObject(hdc, hpold));
		}

		for(e = smaf->events; e; e = e->next)
		{
			DWORD gtime;

			if((e->status & 0xF0) != 0x80 && (e->status & 0xF0) != 0x90)	// Not NoteON
				continue;

			//if(scrx + width < (signed)e->time)	// Over. no draw needed any more.
			//	break;

			if(VisibleTrack != -1 && (e->status & 0x0F) != VisibleTrack)	// NoVisible
				continue;

			if((e->status & 0xF0) == 0x80)	// NonVel
				gtime = GetVVal(e->data + 1) * smaf->gbase;
			else
				gtime = GetVVal(e->data + 2) * smaf->gbase;

			FillRectangle(hdc,	e->time / RollWidth - scrx,
								(127 - e->data[0]) * RollHeight - scry,
								(e->time + gtime) / RollWidth - scrx,
								((127 - e->data[0]) + 1) * RollHeight - scry,
								RGB(128, 64, 128));
			FillRectangle(hdc,	e->time / RollWidth - scrx + 1,
								(127 - e->data[0]) * RollHeight - scry + 1,
								(e->time + gtime) / RollWidth - scrx - 1,
								((127 - e->data[0]) + 1) * RollHeight - scry - 1,
								trackcolors[e->status & 0x0F]);
		}

		// draw vertical grid text
		for(i = -(scrx * (int)RollWidth % 100); i < width * (int)RollWidth; i += 100)
		{
			if((i + scrx * RollWidth) % (50 * RollWidth))
				continue;
			MoveToEx(hdc, i / RollWidth + 2, 0, NULL);
			PutText(hdc, "%ums", i + scrx * RollWidth);
		}

		// draw horizontal grid text
		for(i = 0; i < 128; i++)
		{
			LPCTSTR oto[] = {TEXT("C"), TEXT("C#"), TEXT("D"), TEXT("D#"), TEXT("E"), TEXT("F"), TEXT("F#"), TEXT("G"), TEXT("G#"), TEXT("A"), TEXT("A#"), TEXT("B")};
			MoveToEx(hdc, 1, (127 - i) * RollHeight - scry + 1, NULL);
			PutText(hdc, "%-2s %d", oto[i % 12], i / 12 - 2);
		}

		SetTextColor(hdc, oldcolor);
		DeleteObject(SelectObject(hdc, hpold));
	}

	// Start
	if(smaf->start)
	{
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(0, 128, 0)));

		MoveToEx(hdc, (smaf->start->time - smaf->start->duration) / RollWidth - scrx, 0, NULL);
		LineTo(hdc, (smaf->start->time - smaf->start->duration) / RollWidth - scrx, height);

		DeleteObject(SelectObject(hdc, hpold));
	}
	// End
	if(smaf->stop)
	{
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(128, 0, 128)));

		MoveToEx(hdc, smaf->stop->time / RollWidth - scrx, 0, NULL);
		LineTo(hdc, smaf->stop->time / RollWidth - scrx, height);

		DeleteObject(SelectObject(hdc, hpold));
	}

	// Current
	{
		HPEN hpold = SelectObject(hdc, CreatePen(PS_SOLID, 1, RGB(255, 0, 0)));

		MoveToEx(hdc, playingpos / RollWidth - scrx, 0, NULL);
		LineTo(hdc, playingpos / RollWidth - scrx, height);

		DeleteObject(SelectObject(hdc, hpold));
	}

	if(VisibleTrack != -1)
	{
		SIZE s;
		TCHAR ts[32];

		SetBkMode(hdc, OPAQUE);
		SetBkColor(hdc, RGB(255, 255, 255));
		SetTextColor(hdc, RGB(255, 0, 0));

		wsprintf(ts, "Viewing Track %d", VisibleTrack + 1);

		GetTextExtentPoint32(hdc, ts, lstrlen(ts), &s);
		TextOut(hdc, width - s.cx, height - s.cy, ts, lstrlen(ts));
	}

	DeleteObject(SelectObject(hdc, hfold));

	return;
}

void FreeSmaf(SMAF* smaf)
{
	if(!smaf)
	{
		MessageBox(NULL, "smaf == NULL", "BUG", MB_ICONERROR | MB_OK);
		return;
	}

	if(smaf->data)
		hfree(smaf->data);

	ClearEvents(smaf);

	hfree(smaf);

	return;
}

SMAF* LoadSmaf(LPCTSTR fname)
{
	SMAF* smaf = NULL;
	HANDLE hf = NULL;
	DWORD read;

	if(!(smaf = halloc(sizeof(SMAF))))
		goto Error;

	smaf->data = NULL;
	smaf->events = NULL;

	smaf->start = NULL;
	smaf->stop = NULL;

	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		TCHAR ts[MAX_PATH + 80];

		wsprintf(ts, "Can't open %s", fname);
		MessageBox(NULL, ts, "Error", MB_ICONERROR | MB_OK);

		goto Error;
	}

	smaf->size = GetFileSize(hf, NULL);

	if(!(smaf->data = halloc(smaf->size)))
	{
		MessageBox(NULL, "Can't alloc memory", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}
	if(!ReadFile(hf, smaf->data, smaf->size, &read, NULL))
	{
		read = 0;
	}
	if(read < smaf->size)
	{
		MessageBox(NULL, "Couldn't read file.", "Error", MB_ICONERROR | MB_OK);
		goto Error;
	}

	CloseHandle(hf);

	{
		CHUNK chk;
		CHUNK mtr;
		DWORD chkplus;
		DWORD chshift;

		if(!findchunk4(smaf->data, smaf->size, "MMMD", &chk))
		{
			MessageBox(NULL, "This is not SMAF", "Error", MB_ICONERROR | MB_OK);
			goto Error;
		}

		chk.size -= 2;	// MMMD's CRC

		// MTRւ̑Ή
		for(chkplus = 0, chshift = 0; chkplus < chk.size; chshift += 4)
		{
			if(!findchunk3(chk.data + chkplus, chk.size, "MTR", &mtr))
				break;

			chkplus = (mtr.data - chk.data) + mtr.size;

			{
				CHUNK dummy;

				switch(mtr.data[2])
				{
				case 0x00: smaf->dbase = 1; break;
				case 0x01: smaf->dbase = 2; break;
				case 0x02: smaf->dbase = 4; break;
				case 0x03: smaf->dbase = 5; break;
				case 0x10: smaf->dbase = 10; break;
				case 0x11: smaf->dbase = 20; break;
				case 0x12: smaf->dbase = 40; break;
				case 0x13: smaf->dbase = 50; break;
				default: MessageBox(NULL, "Unknown duration timebase", "Error", MB_ICONERROR | MB_OK); goto Error;
				}

				switch(mtr.data[3])
				{
				case 0x00: smaf->gbase = 1; break;
				case 0x01: smaf->gbase = 2; break;
				case 0x02: smaf->gbase = 4; break;
				case 0x03: smaf->gbase = 5; break;
				case 0x10: smaf->gbase = 10; break;
				case 0x11: smaf->gbase = 20; break;
				case 0x12: smaf->gbase = 40; break;
				case 0x13: smaf->gbase = 50; break;
				default: MessageBox(NULL, "Unknown gatetime timebase", "Error", MB_ICONERROR | MB_OK); goto Error;
				}

				if(mtr.data[0] == 0x00)	// HPS
				{
					DWORD start, stop;

					mtr.data += 4 + 2;	// skip ChStatus

					// init start,stop.
					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						start = 0;
						stop = mtr.size;
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						ConvertEvents2(smaf, dummy.data, dummy.size, TRUE, 0, 0, chshift);

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
					{
						BYTE* p = dummy.data;

						while(p < dummy.data + dummy.size)
						{
							if(*p == 'S' && *(p + 1) == 'T')
							{
								p += 3;
								start = *(DWORD*)p;
								p += 4;
							}
							if(*p == 'S' && *(p + 1) == 'P')
							{
								p += 3;
								stop = *(DWORD*)p;
								p += 4;
							}
							if(*p != ',')
								break;
							p++;
						}
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
						ConvertEvents2(smaf, dummy.data, dummy.size, FALSE, start, stop, chshift);
				}

				if(mtr.data[0] == 0x01 || mtr.data[0] == 0x02)	// MSF
				{
					DWORD start, stop;

					mtr.data += 4 + 16;

					// init start,stop.
					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						start = 0;
						stop = mtr.size;
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsu", &dummy))
						ConvertEvents(smaf, dummy.data, dummy.size, TRUE, 0, 0);

					if(findchunk4(mtr.data, mtr.size, "MspI", &dummy))
					{
						BYTE* p = dummy.data;

						while(p < dummy.data + dummy.size)
						{
							if(*p == 's' && *(p + 1) == 't')
							{
								p += 3;
								start = SwapDword(p);
								p += 4;
							}
							if(*p == 's' && *(p + 1) == 'p')
							{
								p += 3;
								stop = SwapDword(p);
								p += 4;
							}
							if(*p != ',')
								break;
							p++;
						}
					}

					if(findchunk4(mtr.data, mtr.size, "Mtsq", &dummy))
					{
						if(mtr.data[-20] == 0x01)
						{
							BYTE* data;

							data = halloc(SwapDword(dummy.data));
							huffmanDecode(data, dummy.data + 4, SwapDword(dummy.data), dummy.size);
							ConvertEvents(smaf, data, SwapDword(dummy.data), FALSE, start, stop);
							hfree(data);
						}
						if(mtr.data[-20] == 0x02)
							ConvertEvents(smaf, dummy.data, dummy.size, FALSE, start, stop);
					}
				}
			}
		}
	}

	return smaf;
Error:
	if(smaf)
	{
		FreeSmaf(smaf);
	}
	if(hf)
	{
		CloseHandle(hf);
	}

	return NULL;
}

void getTrackMenuItem(int id, LPTSTR str, COLORREF* fg, COLORREF* bg)
{
	COLORREF dummy;

	if(!fg)
		fg = &dummy;
	if(!bg)
		bg = &dummy;

	switch(id)
	{
	case ID_VTRACK1:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[0];	lstrcpy(str, "1:Track1(Silver)");		break;
	case ID_VTRACK2:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[1];	lstrcpy(str, "2:Track2(Red)");			break;
	case ID_VTRACK3:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[2];	lstrcpy(str, "3:Track3(Green)");		break;
	case ID_VTRACK4:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[3];	lstrcpy(str, "4:Track4(Blue)");			break;
	case ID_VTRACK5:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[4];	lstrcpy(str, "5:Track5(Yellow)");		break;
	case ID_VTRACK6:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[5];	lstrcpy(str, "6:Track6(Cyan)");			break;
	case ID_VTRACK7:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[6];	lstrcpy(str, "7:Track7(Purple)");		break;
	case ID_VTRACK8:	*fg = RGB(  0,   0,   0);	*bg = trackcolors[7];	lstrcpy(str, "8:Track8(White)");		break;
	case ID_VTRACK9:	*fg = RGB(255, 255, 255);	*bg = trackcolors[8];	lstrcpy(str, "Q:Track9(Black)");		break;
	case ID_VTRACK10:	*fg = RGB(255, 255, 255);	*bg = trackcolors[9];	lstrcpy(str, "W:Track10(DarkRed)");		break;
	case ID_VTRACK11:	*fg = RGB(255, 255, 255);	*bg = trackcolors[10];	lstrcpy(str, "E:Track11(DarkGreen)");	break;
	case ID_VTRACK12:	*fg = RGB(255, 255, 255);	*bg = trackcolors[11];	lstrcpy(str, "R:Track12(DarkBlue)");	break;
	case ID_VTRACK13:	*fg = RGB(255, 255, 255);	*bg = trackcolors[12];	lstrcpy(str, "T:Track13(DarkYellow)");	break;
	case ID_VTRACK14:	*fg = RGB(255, 255, 255);	*bg = trackcolors[13];	lstrcpy(str, "Y:Track14(DarkCyan)");	break;
	case ID_VTRACK15:	*fg = RGB(255, 255, 255);	*bg = trackcolors[14];	lstrcpy(str, "U:Track15(DarkPurple)");	break;
	case ID_VTRACK16:	*fg = RGB(255, 255, 255);	*bg = trackcolors[15];	lstrcpy(str, "I:Track16(Gray)");		break;
	}

	return;
}

void seek(SMAF* smaf, UINT ppos, BOOL emuseek, BOOL forcemove)
{
	PlayingPos = ppos;

	if(emuseek)
	{
		MaSound_Stop(1, 1, 0);
		if(MaSound_Seek(1, 1, PlayingPos - (smaf->start->time - smaf->start->duration), 0, 0))
		{
			MessageBox(hMainWnd, "Seek failed", "Error", MB_ICONERROR | MB_OK);
		}
		MaSound_Start(1, 1, 1, 0);
	}

	if(forcemove)
	{
		if(FollowPlay)
			SetScrollPos(hMainWnd, SB_HORZ, (int)(PlayingPos + FollowSpace) / (int)RollWidth, TRUE);
	}else
	{
		if(FollowPlay == 1 || (FollowPlay == 2 && GetAsyncKeyState(VK_SHIFT) & 0x8000))
			SetScrollPos(hMainWnd, SB_HORZ, (int)(PlayingPos + FollowSpace) / (int)RollWidth, TRUE);
	}

	InvalidateRect(hMainWnd, NULL, FALSE);
	InvalidateRect(hDetailWnd, NULL, FALSE);

	return;
}

// check this function
void setExclusiveCh(BYTE* data, CHPARAM* chp)
{
	data[0] = 0xF0;
	data[1] = 0x43;
	data[2] = 0x79;
	data[3] = 0x07;
	data[4] = 0x7F;
	data[5] = 0x01;
	data[6] = chp->bm;
	data[7] = chp->bl;
	data[8] = chp->pc;
	data[11] &= ~0x30;
	data[11] |= ((chp->lfo & 0x02) ? 0x10 : 0) | ((chp->pan & 0x10) ? 0x20 : 0);
	data[13] &= ~0x78;
	data[13] |= ((chp->pan & 0x0F) << 3);
	data[14] |= ((chp->lfo & 0x01) ? 0x40 : 0) | ((chp->pe) ? 0x20 : 0) | (chp->alg);

	return;
}

// CHECK THIS FUNCTION
void setExclusiveOp(BYTE* data, OPPARAM* opp)
{
	// X1 XX XX XX 23 45 67 89 AX BC DE FG

	data[0] &= ~0x0F;
	data[0] |= ((opp->sr & 0x08) ? 8 : 0) | ((opp->rr & 0x08) ? 4 : 0) | ((opp->ar & 0x08) ? 2 : 0) | ((opp->tl & 0x20) ? 1 : 0);

	data[4] = ((opp->sr & 0x07) << 4) | (opp->xof ? 8 : 0) | (opp->sus ? 2 : 0) | (opp->ksr ? 1 : 0);
	data[5] = ((opp->rr & 0x07) << 4) | (opp->dr);
	data[6] = ((opp->ar & 0x07) << 4) | (opp->sl);
	data[7] = ((opp->tl & 0x1F) << 2) | (opp->ksl);
	data[8] &= ~0x30;
	data[8] |= ((opp->multi & 0x08) ? 0x20 : 0) | ((opp->ws & 0x10) ? 0x10 : 0);
	data[9] = ((opp->dam) << 5) | ((opp->eam) ? 0x10 : 0) | ((opp->dvb) << 1) | ((opp->evb) ? 1 : 0);
	data[10] = ((opp->multi & 0x07) << 4) | (opp->dt);
	data[11] = ((opp->ws & 0x0F) << 3);

	return;
}

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static BOOL sounding = FALSE;
	static SMAF* smaf = NULL;
	static int refrate = 10;

	static int inputtingnum;
	static char inputtingtype;
	static BOOL isinputting = FALSE;
	static BOOL isinputfirst;

	static int sndy;

	switch(msg)
	{
	case WM_CREATE:
		EmuInit();

		break;
	case WM_MOUSEWHEEL:
		if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
		{
			if((short)HIWORD(wParam) > 0)
				PostMessage(hWnd, WM_HSCROLL, SB_PAGELEFT, 0);
			else
				PostMessage(hWnd, WM_HSCROLL, SB_PAGERIGHT, 0);
		}else
		{
			if((short)HIWORD(wParam) > 0)
				PostMessage(hWnd, WM_VSCROLL, SB_PAGEUP, 0);
			else
				PostMessage(hWnd, WM_VSCROLL, SB_PAGEDOWN, 0);
		}
		break;
	case WM_KEYDOWN:
		if((int)wParam == VK_SHIFT)
			if(!isinputting)
			{
				isinputting = TRUE;
				isinputfirst = TRUE;
				inputtingnum = 0;
				inputtingtype = 0;
				InvalidateRect(hWnd, NULL, FALSE);
			}

		if(isinputting)
		{
			if('0' <= (int)wParam && (int)wParam <= '9')
			{
				if(isinputfirst)
				{
					isinputfirst = FALSE;
					inputtingnum = 0;
				}
				inputtingnum = inputtingnum * 10 + (int)wParam - '0';
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if((int)wParam == VK_OEM_MINUS)
			{
				inputtingnum = -inputtingnum;
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if((int)wParam == VK_BACK || (int)wParam == VK_DELETE)
			{
				inputtingnum = inputtingnum / 10;
				InvalidateRect(hWnd, NULL, FALSE);
			}
			if(('A' <= (int)wParam && (int)wParam <= 'Z') || (int)wParam == VK_ESCAPE)
			{
				inputtingtype = (char)wParam;
				isinputfirst = TRUE;
				switch(inputtingtype)
				{
				case 'R':
					inputtingnum = refrate;
					break;
				case 'D':
					inputtingnum = DrawFunc;
					break;
				case 'H':
					inputtingnum = RollHeight;
					break;
				case 'T':
					inputtingnum = EmuPlayTempo;
					break;
				case 'K':
					inputtingnum = EmuPlayKeypitch;
					break;
				case 'W':
					inputtingnum = RollWidth;
					break;
				case 'F':
					inputtingnum = FollowPlay;
					break;
				case 'S':
					inputtingnum = -FollowSpace;
					break;
				case 'G':
					if(smaf)
						inputtingnum = PlayingPos;
					break;
				case 'V':
					inputtingnum = EmuPlayVolume;
					break;
				case 'M':
					if(smaf)
						inputtingnum = GetScrollPos(hWnd, SB_HORZ) * RollWidth;
					break;
				}
				InvalidateRect(hWnd, NULL, FALSE);
			}
		}else
		{
			switch((int)wParam)
			{
			case '0':	VisibleTrack = -1;	InvalidateRect(hWnd, NULL, FALSE);	break;

			case '1':	VisibleTrack = 0;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '2':	VisibleTrack = 1;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '3':	VisibleTrack = 2;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '4':	VisibleTrack = 3;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '5':	VisibleTrack = 4;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '6':	VisibleTrack = 5;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '7':	VisibleTrack = 6;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case '8':	VisibleTrack = 7;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'Q':	VisibleTrack = 8;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'W':	VisibleTrack = 9;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'E':	VisibleTrack = 10;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'R':	VisibleTrack = 11;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'T':	VisibleTrack = 12;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'Y':	VisibleTrack = 13;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'U':	VisibleTrack = 14;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case 'I':	VisibleTrack = 15;	InvalidateRect(hWnd, NULL, FALSE);	break;
			}
		}

		switch((int)wParam)
		{
		case VK_LEFT:
			if(smaf)
			{
				UINT movval = 1000;

				if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
					movval = 100;

				if((smaf->start->time - smaf->start->duration) + movval <= PlayingPos)
					seek(smaf, PlayingPos - movval, sounding, FALSE);
				else
					seek(smaf, smaf->start->time - smaf->start->duration, sounding, FALSE);

				{
					TCHAR ts[32];

					wsprintf(ts, "MMF Tool %06ums", PlayingPos);
					SetWindowText(hWnd, ts);
				}
			}
			break;
		case VK_RIGHT:
			if(smaf)
			{
				UINT movval = 1000;

				if(GetAsyncKeyState(VK_CONTROL) & 0x8000)
					movval = 100;

				seek(smaf, PlayingPos + movval, sounding, FALSE);

				{
					TCHAR ts[32];

					wsprintf(ts, "MMF Tool %06ums", PlayingPos);
					SetWindowText(hWnd, ts);
				}
			}
			break;
		}
		break;
	case WM_KEYUP:
		if((int)wParam == VK_SHIFT)
			if(isinputting)
			{
				isinputting = FALSE;
				switch(inputtingtype)
				{
				case 'R':
					if(0 < inputtingnum)
						refrate = inputtingnum;
					if(sounding)
					{
						KillTimer(hWnd, 0);
						SetTimer(hWnd, 0, refrate, NULL);
					}
					break;
				case 'D':
					if(0 <= inputtingnum && inputtingnum <= 2)
						DrawFunc = inputtingnum;
					break;
				case 'H':
					if(0 < inputtingnum)
						RollHeight = inputtingnum;
					break;
				case 'T':
					if(70 <= inputtingnum && inputtingnum <= 130)
					{
						// e|(%) between 70 to 130.
						EmuPlayTempo = inputtingnum;
						if(sounding && MaSound_Control(1, 1, 1, &EmuPlayTempo, 0))
						{
							MessageBox(NULL, "Control tempo failed!", "Error", MB_ICONERROR | MB_OK);
						}
					}
					break;
				case 'K':
					if(-12 <= inputtingnum && inputtingnum <= 12)
					{
						// L[sb` between -12 to 12
						EmuPlayKeypitch = inputtingnum;
						if(sounding && MaSound_Control(1, 1, 2, &EmuPlayKeypitch, 0))
						{
							MessageBox(NULL, "Control keypitch failed!", "Error", MB_ICONERROR | MB_OK);
						}
					}
					break;
				case 'W':
					if(0 < inputtingnum)
					{
						UINT curr;

						curr = GetScrollPos(hWnd, SB_HORZ) * RollWidth;

						RollWidth = inputtingnum;
						if(smaf)
							SetScrollPos(hWnd, SB_HORZ, (int)curr / (int)RollWidth, TRUE);
					}
					break;
				case 'F':
					if(0 <= inputtingnum && inputtingnum <= 2)
						FollowPlay = inputtingnum;
					break;
				case 'S':
					FollowSpace = -inputtingnum;
					break;
				case 'G':
					if(smaf && 0 <= inputtingnum)
					{
						seek(smaf, inputtingnum, sounding, TRUE);

						{
							TCHAR ts[32];

							wsprintf(ts, "MMF Tool %06ums", PlayingPos);
							SetWindowText(hWnd, ts);
						}
					}
					break;
				case 'V':
					if(0 <= inputtingnum && inputtingnum <= 127)
					{
						//  between 0 to 127
						EmuPlayVolume = inputtingnum;
						if(sounding && MaSound_Control(1, 1, 0, &EmuPlayVolume, 0))
						{
							MessageBox(NULL, "Control volume failed!", "Error", MB_ICONERROR | MB_OK);
						}
					}
					break;
				case 'M':
					if(smaf && 0 <= inputtingnum)
						SetScrollPos(hWnd, SB_HORZ, (int)(inputtingnum) / (int)RollWidth, TRUE);
					break;
				}
				InvalidateRect(hWnd, NULL, FALSE);
			}
		break;
	case WM_HSCROLL:
	case WM_VSCROLL:
		{
			SCROLLINFO scr;

			scr.cbSize = sizeof(scr);
			scr.fMask = SIF_ALL;
			if(msg == WM_HSCROLL)
				GetScrollInfo(hWnd, SB_HORZ, &scr);
			if(msg == WM_VSCROLL)
				GetScrollInfo(hWnd, SB_VERT, &scr);

			switch(LOWORD(wParam))
			{
			//case SB_TOP:
			case SB_LEFT:
				scr.nPos = scr.nMin;
				break;
			//case SB_BOTTOM:
			case SB_RIGHT:
				scr.nPos = scr.nMax;
				break;
			//case SB_LINEUP:
			case SB_LINELEFT:
				if(scr.nMin < scr.nPos)
					scr.nPos--;
				break;
			//case SB_LINEDOWN:
			case SB_LINERIGHT:
				if(scr.nPos < scr.nMax - 1)
					scr.nPos++;
				break;
			//case SB_PAGEUP:
			case SB_PAGELEFT:
				scr.nPos -= scr.nPage;
				break;
			//case SB_PAGEDOWN:
			case SB_PAGERIGHT:
				scr.nPos += scr.nPage;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				scr.nPos = HIWORD(wParam);
				break;
			}

			scr.fMask = SIF_POS;
			if(msg == WM_HSCROLL)
				SetScrollInfo(hWnd, SB_HORZ, &scr, TRUE);
			if(msg == WM_VSCROLL)
				SetScrollInfo(hWnd, SB_VERT, &scr, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			RECT rc;

			HDC hdcbg;
			HBITMAP oldbmp;
			BITMAPINFO bi = {0};

			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
				bi.bmiHeader.biPlanes = 1;
				bi.bmiHeader.biWidth = rc.right;
				bi.bmiHeader.biHeight = rc.bottom;
				bi.bmiHeader.biBitCount = 24;
				oldbmp = SelectObject(hdc, CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, NULL, NULL, 0));

				break;
			case 2:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				oldbmp = SelectObject(hdc, CreateCompatibleBitmap(hdcbg, rc.right, rc.bottom));

				break;
			}

			draw(hWnd, hdc, rc.right, rc.bottom, smaf, PlayingPos);
			if(isinputting)
			{
				MoveToEx(hdc, 0, 0, NULL);
				SaveDC(hdc);
				SetBkMode(hdc, OPAQUE);
				SetBkColor(hdc, RGB(255, 255, 255));
				SetTextColor(hdc, RGB(0, 0, 0));
				switch(inputtingtype)
				{
				case 0:
					break;
				case VK_ESCAPE:
					PutText(hdc, "(Escape)");
					break;
				case 'R':
					PutText(hdc, "Refresh Rate: %d", inputtingnum);
					break;
				case 'D':
					PutText(hdc, "Draw Function: %d", inputtingnum);
					break;
				case 'H':
					PutText(hdc, "PianoRoll's Height: %d", inputtingnum);
					break;
				case 'T':
					PutText(hdc, "Tempo: %d", inputtingnum);
					break;
				case 'K':
					PutText(hdc, "KeyPitch: %d", inputtingnum);
					break;
				case 'W':
					PutText(hdc, "PianoRoll's Width divider: %d", inputtingnum);
					break;
				case 'F':
					PutText(hdc, "Follow play: %d", inputtingnum);
					break;
				case 'S':
					PutText(hdc, "Follow space: %d", -inputtingnum);
					break;
				case 'G':
					if(smaf)
						PutText(hdc, "GoTo: %d", inputtingnum);
					else
						PutText(hdc, "SMAF not opened", inputtingnum);
					break;
				case 'V':
					PutText(hdc, "Volume: %d", inputtingnum);
					break;
				case 'M':
					PutText(hdc, "MoveTo: %d", inputtingnum);
					break;
				default:
					if(smaf)
						PutText(hdc, "INVALID TYPE");
					else
						PutText(hdc, "SMAF not opened", inputtingnum);
					break;
				}
				RestoreDC(hdc, -1);
			}

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
			case 2:
				BitBlt(hdcbg, 0, 0, rc.right, rc.bottom, hdc, 0, 0, SRCCOPY);

				DeleteObject(SelectObject(hdc, oldbmp));
				DeleteDC(hdc);

				break;
			}

			EndPaint(hWnd, &ps);
		}
		break;
	case WM_INITMENUPOPUP:
		{
			HMENU hm = (HMENU)wParam;
			int i;
			int max = GetMenuItemCount(hm);

			for(i = 0; i < max; i++)
			{
				MENUITEMINFO mii = {0};

				mii.cbSize = sizeof(mii);
				mii.fMask = MIIM_ID;
				GetMenuItemInfo(hm, i, TRUE, &mii);
				switch(mii.wID)
				{
				case ID_VTRACK1:
				case ID_VTRACK2:
				case ID_VTRACK3:
				case ID_VTRACK4:
				case ID_VTRACK5:
				case ID_VTRACK6:
				case ID_VTRACK7:
				case ID_VTRACK8:
				case ID_VTRACK9:
				case ID_VTRACK10:
				case ID_VTRACK11:
				case ID_VTRACK12:
				case ID_VTRACK13:
				case ID_VTRACK14:
				case ID_VTRACK15:
				case ID_VTRACK16:
					mii.fMask = MIIM_ID | MIIM_TYPE;
					mii.fType = MFT_OWNERDRAW;
					SetMenuItemInfo(hm, i, TRUE, &mii);
					break;
				}
			}
		}
		break;
	case WM_MEASUREITEM:
		{
			LPMEASUREITEMSTRUCT mis = (LPMEASUREITEMSTRUCT)lParam;

			if(mis->CtlType == ODT_MENU)
			{	// ͂Ђǂ
				HDC hmwdc;
				HDC hdc;
				NONCLIENTMETRICS ncm;
				HFONT hfold;
				SIZE s;
				TCHAR str[256];

				hmwdc = GetDC(hWnd);
				hdc = CreateCompatibleDC(hmwdc);

				ncm.cbSize = sizeof(ncm);
				SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(ncm), &ncm, 0);

				hfold = SelectObject(hdc, CreateFontIndirect(&ncm.lfMenuFont));

				getTrackMenuItem(mis->itemID, str, NULL, NULL);
				GetTextExtentPoint32(hdc, str, lstrlen(str), &s);
				mis->itemWidth = s.cx + 4;
				mis->itemHeight = s.cy + 4;

				DeleteObject(SelectObject(hdc, hfold));
				DeleteDC(hdc);
				ReleaseDC(hWnd, hmwdc);
			}
		}
		break;
	case WM_DRAWITEM:
		{
			LPDRAWITEMSTRUCT dis = (LPDRAWITEMSTRUCT)lParam;

			if(dis->CtlType == ODT_MENU)
			{
				TCHAR str[256];
				MENUITEMINFO mii = {0};
				COLORREF bg = 0xFF000000, fg;

				getTrackMenuItem(dis->itemID, str, &fg, &bg);

				if(bg != 0xFF000000)
				{
					SIZE s;

					SaveDC(dis->hDC);
					SetBkMode(dis->hDC, TRANSPARENT);

					if(dis->itemState & ODS_SELECTED)
					{
						SetTextColor(dis->hDC, fg);
						FillRectangle(dis->hDC, dis->rcItem.left, dis->rcItem.top, dis->rcItem.right, dis->rcItem.bottom, RGB(128, 0, 128));
						FillRectangle(dis->hDC, dis->rcItem.left + 1, dis->rcItem.top + 1, dis->rcItem.right - 1, dis->rcItem.bottom - 1, bg);
					}else
						FillRectangle(dis->hDC, dis->rcItem.left, dis->rcItem.top, dis->rcItem.right, dis->rcItem.bottom, GetSysColor(COLOR_3DFACE));

					GetTextExtentPoint32(dis->hDC, str, lstrlen(str), &s);

					TextOut(dis->hDC, dis->rcItem.left + 2, dis->rcItem.top + (dis->rcItem.bottom - dis->rcItem.top - s.cy) / 2, str, lstrlen(str));

					RestoreDC(dis->hDC, -1);
				}
			}
		}
		break;
	case WM_COMMAND:
		switch(HIWORD(wParam))
		{
		case 0:	// Command
		case 1:	// Accelerator
			switch(LOWORD(wParam))
			{
			case ID_OPENSMAF:
				{
					OPENFILENAME ofn = {0};
					TCHAR fname[MAX_PATH];

					ofn.lStructSize = sizeof(ofn);
					ofn.Flags = OFN_FILEMUSTEXIST;
					ofn.hInstance = GetModuleHandle(NULL);
					ofn.hwndOwner = hWnd;
					ofn.lpstrTitle = "Open SMAF";
					fname[0] = '\0';
					ofn.lpstrFile = fname;
					ofn.nMaxFile = sizeof(fname);
					ofn.lpstrFilter = "SMAF file(*.mmf)\0*.mmf\0";

					if(GetOpenFileName(&ofn))
					{
						if(smaf)
							SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);

						PlayingPos = 0;

						smaf = LoadSmaf(fname);
						EmuOpen(smaf);

						SetScrollPos(hWnd, SB_HORZ, 0, TRUE);
						SetScrollPos(hWnd, SB_VERT, 0, TRUE);

						SendMessage(hDetailWnd, WM_USER, 0, (LPARAM)smaf);

						{
							TCHAR ts[32];

							wsprintf(ts, "MMF Tool %06ums", PlayingPos);
							SetWindowText(hWnd, ts);
						}

						InvalidateRect(hWnd, NULL, FALSE);
					}
				}
				break;
			case ID_CLOSE:
				if(smaf)
				{
					if(sounding)
						SendMessage(hWnd, WM_COMMAND, ID_STOP, 0);
					EmuClose();
					FreeSmaf(smaf);
					smaf = NULL;

					SendMessage(hDetailWnd, WM_USER, 0, (LPARAM)smaf);

					SetWindowText(hWnd, "MMF Tool");

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_EXIT:
				PostMessage(hWnd, WM_CLOSE, 0, 0);
				break;
			case ID_HELPINDEX:
				MessageBox(hWnd, "There are no help.", "sorry", MB_ICONERROR | MB_OK);
				break;
			case ID_ABOUT:
				DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_ABOUT), hWnd, MessageDlgWndProc, 0);
				break;
			case ID_PLAY:
				if(smaf && !sounding)
				{
					SetWindowText(hWnd, "MMF Tool <Starting play...>");

					EmuPlay(smaf);
					sounding = TRUE;
					SetTimer(hWnd, 0, refrate, NULL);
				}
				break;
			case ID_STOP:
				if(smaf && sounding)
				{
					SetWindowText(hWnd, "MMF Tool <Stopping play...>");

					EmuStop();
					sounding = FALSE;
					KillTimer(hWnd, 0);

					{
						TCHAR ts[32];

						wsprintf(ts, "MMF Tool %06ums", PlayingPos);
						SetWindowText(hWnd, ts);
					}

					InvalidateRect(hWnd, NULL, FALSE);
				}
				break;
			case ID_REWIND:
				if(smaf)
				{
					seek(smaf, smaf->start->time - smaf->start->duration, sounding, FALSE);

					{
						TCHAR ts[32];

						wsprintf(ts, "MMF Tool %06ums", PlayingPos);
						SetWindowText(hWnd, ts);
					}
				}
				break;
			case ID_DETAILWND:
				ShowWindow(hDetailWnd, SW_SHOW);
				break;
			case ID_VTRACKALL:	VisibleTrack = -1;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK1:	VisibleTrack = 0;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK2:	VisibleTrack = 1;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK3:	VisibleTrack = 2;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK4:	VisibleTrack = 3;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK5:	VisibleTrack = 4;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK6:	VisibleTrack = 5;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK7:	VisibleTrack = 6;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK8:	VisibleTrack = 7;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK9:	VisibleTrack = 8;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK10:	VisibleTrack = 9;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK11:	VisibleTrack = 10;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK12:	VisibleTrack = 11;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK13:	VisibleTrack = 12;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK14:	VisibleTrack = 13;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK15:	VisibleTrack = 14;	InvalidateRect(hWnd, NULL, FALSE);	break;
			case ID_VTRACK16:	VisibleTrack = 15;	InvalidateRect(hWnd, NULL, FALSE);	break;
			}
			break;
		}
		break;
	case WM_LBUTTONDOWN:
		if(smaf)
		{
			seek(smaf, (GetScrollPos(hWnd, SB_HORZ) + LOWORD(lParam)) * RollWidth, sounding, FALSE);

			{
				TCHAR ts[32];

				wsprintf(ts, "MMF Tool %06ums", PlayingPos);
				SetWindowText(hWnd, ts);
			}
		}
		break;
	case WM_RBUTTONDOWN:
		{
			int y = (GetScrollPos(hWnd, SB_VERT) + HIWORD(lParam)) / RollHeight;

			if(!smaf)
				break;

			if(sounding)
				break;

			if(128 <= y)
				break;

			y = 127 - y;

			// MONOPHOLIC EXCLUSIVES?
			{
				BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x13, 0x00, 0xF7};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsgX1 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			{
				BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x11, 0x00, 0xF7};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsgX2 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}

			// MasterVolume
			{
				BYTE cmd[] = {0xF0, 0x43, 0x79, 0x05, 0x7E, 0x09, EmuPlayVolume, 0xF7};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsgX3 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			// exclusives
			{
				BYTE cmd[] = {0xF0, 0x43, 0x79, 0x06, 0x7F, 0x02, 0x7C, 0x00, 0x00, 0x00, 0xF7};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsgX4 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			/* escape Tr01
			0xF0, 0x43, 0x79, 0x06, 0x7F, 0x01, 0x7C, 0x01,
			0x00, 0x00, 0x00, 0x16, 0x00, 0x79, 0x65, 0x02,
			0x4F, 0x74, 0x1D, 0x06, 0x00, 0x20, 0x40, 0x02,
			0x4F, 0x70, 0x02, 0x06, 0x07, 0x10, 0x00, 0x02,
			0x2F, 0x73, 0x32, 0x06, 0x00, 0x20, 0x00, 0x02,
			0x4F, 0x70, 0x02, 0x00, 0x01, 0x10, 0x40, 0xF7,
			*/
			/*
			BYTE cmd[] = {
				0xF0, 0x43, 0x79, 0x07, 0x7F, 0x01, 0x7C, 0x01,
				0x09, 0x00, 0x00, 0x00, 0x79, 0x43, 0x02, 0x67,
				0xFF, 0x9D, 0x00, 0x10, 0x40, 0x23, 0x33, 0xE2,
				0x73, 0x00, 0x50, 0x00, 0x12, 0x41, 0xD3, 0x58,
				0x01, 0x10, 0x00, 0x23, 0x63, 0xD4, 0x02, 0x01,
				0x10, 0x00, 0xF7,
			};
			*/
			{
				/*
				BYTE cmd[] = {
					// Piano
					0xF0, 0x43, 0x79, 0x07, 0x7F, 0x01, 0x7C, 0x00,
					0x00, 0x00, 0x00, 0x03, 0x00, 0x79, 0x43, 0x02,
					0x67, 0x7F, 0x1D, 0x02, 0x00, 0x10, 0x40, 0x23,
					0x33, 0x62, 0x73, 0x02, 0x00, 0x50, 0x00, 0x12,
					0x41, 0x53, 0x58, 0x02, 0x01, 0x10, 0x00, 0x23,
					0x63, 0x54, 0x02, 0x00, 0x01, 0x10, 0x00, 0xF7,
				};
				*/
#if 0
				BYTE cmd[] = {
					0xF0, 0x43, 0x79, 0x07, 0x7F, 0x01, 0x7C, 0x00, /*-*/ 0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x01, 0x00,
					0x71, 0x7A, 0x00, 0x10, 0x00, 0x00, 0x30, 0x00, /*-*/ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xF7,
					//0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, /*-*/ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
				};
#endif
				BYTE cmd[0x30] = {0};

				/*
				// KUKEIHA
				{
					CHPARAM chp;

					chp.bm = 0x7C;
					chp.bl = 0x00;
					chp.pc = 0x00;
					chp.lfo = 0;
					chp.alg = 1;
					chp.pan = 0;
					chp.pe = FALSE;
					setExclusiveCh(cmd, &chp);
				}
				{
					OPPARAM opp;

					opp.multi = 1;
					opp.dt = 0;//2;
					opp.ar = 15;
					opp.dr = 0;
					opp.sr = 0;
					opp.rr = 15;
					opp.sl = 10;
					opp.tl = 0;
					opp.ksl = 0;
					opp.dam = 0;
					opp.dvb = 0;
					opp.fb = 0;
					opp.ws = 6;

					opp.xof = FALSE;
					opp.sus = FALSE;
					opp.ksr = FALSE;
					opp.eam = FALSE;
					opp.evb = FALSE;

					setExclusiveOp(cmd + 11, &opp);
				}
				{
					OPPARAM opp = {0};

					setExclusiveOp(cmd + 19, &opp);
				}
				cmd[31] = 0xF7;
				*/

				{
					CHPARAM chp = {124, 0, 0, 1, 15, FALSE, 5};
					setExclusiveCh(cmd, &chp);
				}
				{
					OPPARAM opp = {5, 0, 15, 9, 6, 6, 13, 24, 2, 0, 0, 2, 0, FALSE, TRUE, FALSE, FALSE, FALSE};
					setExclusiveOp(cmd + 11, &opp);
				}
				{
					OPPARAM opp = {1, 0, 15, 7, 5, 7, 13, 3, 0, 0, 1, 0, 0, FALSE, TRUE, FALSE, FALSE, TRUE};
					setExclusiveOp(cmd + 19, &opp);
				}
				{
					OPPARAM opp = {5, 0, 15, 6, 6, 6, 10, 29, 2, 0, 0, 0, 0, FALSE, TRUE, TRUE, FALSE, FALSE};
					setExclusiveOp(cmd + 27, &opp);
				}
				{
					OPPARAM opp = {1, 0, 15, 6, 6, 7, 14, 0, 2, 0, 1, 0, 0, FALSE, TRUE, FALSE, FALSE, TRUE};
					setExclusiveOp(cmd + 35, &opp);
				}
				cmd[47] = 0xF7;

				if(SetMidiMsg(cmd, 0x30))
				{
					MessageBox(hWnd, "SetMidiMsgX5 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}

			// ready.

			// CC BankSelect
			{
				BYTE cmd[] = {0xB0, 0x00, 0x7C};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg5 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			{
				BYTE cmd[] = {0xB0, 0x20, 0x00};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg6 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			// PC
			{
				BYTE cmd[] = {0xC0, 0};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg7 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			// NoteON
			{
				BYTE cmd[] = {0x90, y, 0x7F};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg8[sounding] failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}

			sndy = y;
		}
		break;
	case WM_RBUTTONUP:
		{
			if(!smaf)
				break;

			if(sounding)
				break;

			if(sndy == -1)
				break;

			// CC BankSelect
			{
				BYTE cmd[] = {0xB0, 0x00, 0x7C};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg5 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			{
				BYTE cmd[] = {0xB0, 0x20, 0x00};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg6 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			// PC
			{
				BYTE cmd[] = {0xC0, 0};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg7 failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
			// NoteOFF
			{
				BYTE cmd[] = {0x90, sndy, 0x00};
				if(SetMidiMsg(cmd, sizeof(cmd)))
				{
					MessageBox(hWnd, "SetMidiMsg8[sounding] failed", "Error", MB_ICONERROR | MB_OK);
					break;
				}
			}
		}
		break;
	case WM_TIMER:
		if(sounding)
		{
			static DWORD lastrefresh = 0;

			PlayingPos = MaSound_Control(1, 1, 4, 0, 0) + (smaf->start->time - smaf->start->duration);
			EmuStatus(hWnd);
			if(FollowPlay == 1 || (FollowPlay == 2 && GetAsyncKeyState(VK_SHIFT) & 0x8000))
			{
				SetScrollPos(hWnd, SB_HORZ, (int)(PlayingPos + FollowSpace) / (int)RollWidth, TRUE);
			}
			InvalidateRect(hWnd, NULL, FALSE);

			if(lastrefresh + 100 < GetTickCount())
			{
				lastrefresh = GetTickCount();
				InvalidateRect(hDetailWnd, NULL, FALSE);
			}
		}
		break;
	case WM_SIZE:
		{
			SCROLLINFO si;

			si.cbSize = sizeof(si);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;
			si.nMin = 0;
			si.nMax = 65535;
			si.nPage = 10;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);

			si.nMin = 0;
			si.nMax = 256 * 8;
			si.nPage = 10;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;
	case WM_CLOSE:
		if(smaf)
			SendMessage(hWnd, WM_COMMAND, ID_CLOSE, 0);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);

		DestroyWindow(hDetailWnd);

		EmuTerminate();
		break;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

LRESULT CALLBACK DetailWndProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static SMAF* smaf = NULL;
	static UINT line;

	switch(msg)
	{
	case WM_USER:
		smaf = (SMAF*)lParam;
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case WM_MOUSEWHEEL:
		if((short)HIWORD(wParam) > 0)
			PostMessage(hWnd, WM_VSCROLL, SB_PAGEUP, 0);
		else
			PostMessage(hWnd, WM_VSCROLL, SB_PAGEDOWN, 0);
		break;
	case WM_HSCROLL:
	case WM_VSCROLL:
		{
			SCROLLINFO scr;

			scr.cbSize = sizeof(scr);
			scr.fMask = SIF_ALL;
			if(msg == WM_HSCROLL)
				GetScrollInfo(hWnd, SB_HORZ, &scr);
			if(msg == WM_VSCROLL)
				GetScrollInfo(hWnd, SB_VERT, &scr);

			switch(LOWORD(wParam))
			{
			//case SB_TOP:
			case SB_LEFT:
				scr.nPos = scr.nMin;
				break;
			//case SB_BOTTOM:
			case SB_RIGHT:
				scr.nPos = scr.nMax;
				break;
			//case SB_LINEUP:
			case SB_LINELEFT:
				if(scr.nMin < scr.nPos)
					scr.nPos--;
				break;
			//case SB_LINEDOWN:
			case SB_LINERIGHT:
				if(scr.nPos < scr.nMax - 1)
					scr.nPos++;
				break;
			//case SB_PAGEUP:
			case SB_PAGELEFT:
				scr.nPos -= scr.nPage;
				break;
			//case SB_PAGEDOWN:
			case SB_PAGERIGHT:
				scr.nPos += scr.nPage;
				break;
			case SB_THUMBPOSITION:
			case SB_THUMBTRACK:
				scr.nPos = HIWORD(wParam);
				break;
			}

			scr.fMask = SIF_POS;
			if(msg == WM_HSCROLL)
				SetScrollInfo(hWnd, SB_HORZ, &scr, TRUE);
			if(msg == WM_VSCROLL)
				SetScrollInfo(hWnd, SB_VERT, &scr, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}

		return 0;
	case WM_LBUTTONDOWN:
		InvalidateRect(hWnd, NULL, FALSE);
		break;
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			HDC hdc;
			RECT rc;
			DWORD lins;

			HDC hdcbg;
			HBITMAP oldbmp;
			BITMAPINFO bi = {0};

			hdc = BeginPaint(hWnd, &ps);
			GetClientRect(hWnd, &rc);

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				bi.bmiHeader.biSize = sizeof(BITMAPINFOHEADER);
				bi.bmiHeader.biPlanes = 1;
				bi.bmiHeader.biWidth = rc.right;
				bi.bmiHeader.biHeight = rc.bottom;
				bi.bmiHeader.biBitCount = 24;
				oldbmp = SelectObject(hdc, CreateDIBSection(hdc, &bi, DIB_RGB_COLORS, NULL, NULL, 0));

				break;
			case 2:
				hdcbg = hdc;
				hdc = CreateCompatibleDC(hdcbg);

				oldbmp = SelectObject(hdc, CreateCompatibleBitmap(hdcbg, rc.right, rc.bottom));

				break;
			}

			lins = drawdetail(hWnd, hdc, rc.right, rc.bottom, smaf, PlayingPos);

			switch(DrawFunc)
			{
			case 0:
				break;
			case 1:
			case 2:
				BitBlt(hdcbg, 0, 0, rc.right, rc.bottom, hdc, 0, 0, SRCCOPY);

				DeleteObject(SelectObject(hdc, oldbmp));
				DeleteDC(hdc);

				break;
			}

			EndPaint(hWnd, &ps);

			if(lins != line)
			{
				RECT rc;

				line = lins;
				GetClientRect(hWnd, &rc);
				SendMessage(hWnd, WM_SIZE, 0, MAKELPARAM(rc.right, rc.bottom));
			}
		}
		break;
	case WM_SIZE:
		{
			SCROLLINFO si;

			si.cbSize = sizeof(si);
			si.fMask = SIF_RANGE | SIF_PAGE | SIF_DISABLENOSCROLL;

			si.nMin = 0;
			si.nMax = 65535;
			si.nPage = 10;
			SetScrollInfo(hWnd, SB_HORZ, &si, TRUE);

			si.nMin = 0;
			si.nMax = line;
			si.nPage = 3;
			SetScrollInfo(hWnd, SB_VERT, &si, TRUE);

			InvalidateRect(hWnd, NULL, FALSE);
		}
		break;
	case WM_CLOSE:
		ShowWindow(hWnd, SW_HIDE);
		return 0;
	}

	return DefWindowProc(hWnd, msg, wParam, lParam);
}

BOOL initWnd(void)
{
	WNDCLASSEX wc = {0};
	
	wc.cbSize = sizeof(wc);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAIN));
	wc.lpfnWndProc = MainWndProc;
	wc.lpszClassName = "MMFToolWC";
	wc.lpszMenuName = MAKEINTRESOURCE(IDR_MAIN);

	if(!RegisterClassEx(&wc))
		return FALSE;

	// I don't like WS_OVERLAPPED.
	if(!(hMainWnd = CreateWindowEx(WS_EX_CLIENTEDGE, wc.lpszClassName, "MMF Tool", WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX | WS_MAXIMIZEBOX | WS_VISIBLE | WS_HSCROLL | WS_VSCROLL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL)))
		return FALSE;

	wc.cbSize = sizeof(wc);
	wc.hbrBackground = (HBRUSH)(COLOR_3DFACE + 1);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance = GetModuleHandle(NULL);
	wc.hIcon = LoadIcon(wc.hInstance, MAKEINTRESOURCE(IDI_MAIN));
	wc.lpfnWndProc = DetailWndProc;
	wc.lpszClassName = "MMFToolDetailWC";
	wc.lpszMenuName = NULL;

	if(!RegisterClassEx(&wc))
		return FALSE;

	if(!(hDetailWnd = CreateWindowEx(WS_EX_CLIENTEDGE, wc.lpszClassName, "MMF Tool - DetailView", WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_SIZEBOX | WS_MAXIMIZEBOX | WS_HSCROLL | WS_VSCROLL, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, wc.hInstance, NULL)))
		return FALSE;

	return TRUE;
}

void WinMainCRTStartup(void)
{
	if(!(hEmuDLL = LoadLibrary("M5_EmuSmw5.dll")))
	{
		MessageBox(NULL, "M5_EmuSmw5.dll not found.\nIt requires to run this application.", "Error", MB_ICONERROR | MB_OK);
		ExitProcess(0);
	}

	InitEmuFunctions(hEmuDLL);

	if(!initWnd())
		ExitProcess(0);

	{
		MSG msg;
		HACCEL at;

		at = LoadAccelerators(GetModuleHandle(NULL), MAKEINTRESOURCE(IDR_MAIN));

		while(GetMessage(&msg, NULL, 0, 0))
		{
			if(!TranslateAccelerator(msg.hwnd, at, &msg))
				TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

		FreeLibrary(hEmuDLL);

		ExitProcess(msg.wParam);
	}
}
