#include <windows.h>

int FillRectangle(HDC hdc, int sx, int sy, int ex, int ey, COLORREF cr)
{
	HBRUSH hbrs;
	int ret;
	RECT rc = {sx, sy, ex, ey};

	hbrs = CreateSolidBrush(cr);
	ret = FillRect(hdc, &rc, hbrs);
	DeleteObject(hbrs);

	return ret;
}

void* halloc(DWORD size)
{
	return HeapAlloc(GetProcessHeap(), 0, size);
}

BOOL hfree(void* ptr)
{
	return HeapFree(GetProcessHeap(), 0, ptr);
}

void PutText(HDC hdc, LPCTSTR str, ...)
{
	POINT p;
	SIZE s;
	va_list va;
	TCHAR ts[1024];

	va_start(va, str);

	wvsprintf(ts, str, va);

	GetCurrentPositionEx(hdc, &p);
	GetTextExtentPoint32(hdc, ts, lstrlen(ts), &s);

	// tɃRXg肻
#if 0
	{
		HBITMAP hbm;
		BITMAP bm;

		hbm = GetCurrentObject(hdc, OBJ_BITMAP);
		GetObject(hbm, sizeof(bm), &bm);

		if(bm.bmHeight < p.y)
			goto end;
		if(p.y + s.cy < 0)
			goto end;
	}
#endif

	TextOut(hdc, p.x, p.y, ts, lstrlen(ts));

end:
	MoveToEx(hdc, p.x, p.y + s.cy, NULL);

	va_end(va);

	return;
}

int memcomp(BYTE* p1, BYTE* p2, DWORD size)
{
	while(size && *p1++ == *p2++)
		size--;

	if(!size)
		return 0;
	if(*p1 < *p2)
		return -1;
	else
		return 1;
}

void memcopy(BYTE* dst, BYTE* src, DWORD size)
{
	while(size--)
		*dst++ = *src++;

	return;
}

DWORD strbytes(LPCTSTR str)
{
	DWORD bytes = 0;

	while(*str)
	{
		bytes += CharNext(str) - str;
		str = CharNext(str);
	}

	return bytes;
}

void strcopy(LPTSTR dst, LPCTSTR src)
{
	memcopy((BYTE*)dst, (BYTE*)src, strbytes(src));

	return;
}
